*+
*+
*+    Source Module => H:\DLOADS\FTP\TEMP\STDDEV.PRG
*+
*+    Copyright (C) 1997, Phil Barnett. All Rights Reserved Worldwide.
*+
*+    Functions: Function StdDev()
*+               Function stdDev()
*+
*+    Reformatted by Click! 1.11 on Sep-21-1997 at 10:25 pm
*+
*+

/*
Dave:

>Is there a CLIP 5.x library, or web site,  which has the above &
>STATISTICAL functions? Thanks

Here is my version for a small sample, take out the minus one for the
non-small sample version:

Sorry if the forumula high ASCII characters got translated to the
Windows set. Perhaps saving it in a DOS editor will convert them back.
*/

* John Agusta
* 5/24/90
*

*+
*+
*+    Function StdDev()
*+
*+
*+
function StdDev( ary )

* Standard Deviation on a small sample
*  (Xi - Mean)  (n - 1)
*

local nCount   := len( Ary )
local x
local nAverage
local nSum     := 0
local nNumber  := 0
local nRetVal  := 0

If nCount > 0

   for x := 1 to nCount
      nSum += Ary[ x ]
   next

   nAverage := nSum / nCount

   for x := 1 to nCount
      nNumber += ( Ary[ x ] - nAverage ) ^ 2
   next

   nRetVal := sqrt( nNumber / ( nCount - 1 ) )

endif

return nRetVal

/*
Sincerely,

John Agusta

S & A PC Solutions, Inc.
Clip-4-Win Publisher, Clip-4-Win is Clipper for Windows!
24 Lena Road
Forestburgh, New York 12777

Tel: (914) 794-4647
Fax: (914) 794-6447

WWW: http://www.clip-4-win.com/
Internet: sapcsi@clip-4-win.com
CompuServe: 71650.2251
*/

/*
In article <01bcc206$f168c9a0$6f992599@default>,
 <dbtg@msn.com> wrote:

>Hi everyone, 
>Is there a CLIP 5.x library, or web site,  which has the above &
>STATISTICAL functions? Thanks
*/

*+
*+
*+    Function stdDev()
*+
*+
*+
function stdDev()

local nSum   := 0
local nSum2  := 0
local nCount := 0

goto top
do while ( !eof() )
   nSum  += field->value
   nSum2 += ( FIELD->value * FIELD->value )
   ++ nCount
enddo

return ( iif( nCount <= 1, 0, sqrt( nCount * nSum2 - nSum * nSum ) / nCount ) )

/*
Regards, Ryszard
--
r(ycho)GLAB
Warsaw, Poland
http://www.waw.pdi.net/~rglab/dejavo.htm
*/

*+ EOF: STDDEV.PRG
